<?php

// Data functions (insert, update, delete, form) for table batches

// This script and data application were generated by AppGini 5.62
// Download AppGini for free from https://bigprof.com/appgini/download/

function batches_insert(){
	global $Translation;

	// mm: can member insert record?
	$arrPerm=getTablePermissions('batches');
	if(!$arrPerm[1]){
		return false;
	}

	$data['item'] = makeSafe($_REQUEST['item']);
		if($data['item'] == empty_lookup_value){ $data['item'] = ''; }
	$data['supplier'] = makeSafe($_REQUEST['supplier']);
		if($data['supplier'] == empty_lookup_value){ $data['supplier'] = ''; }
	$data['batch_no'] = makeSafe($_REQUEST['batch_no']);
		if($data['batch_no'] == empty_lookup_value){ $data['batch_no'] = ''; }
	$data['manufacturing_date'] = intval($_REQUEST['manufacturing_dateYear']) . '-' . intval($_REQUEST['manufacturing_dateMonth']) . '-' . intval($_REQUEST['manufacturing_dateDay']);
	$data['manufacturing_date'] = parseMySQLDate($data['manufacturing_date'], '1');
	$data['expiry_date'] = intval($_REQUEST['expiry_dateYear']) . '-' . intval($_REQUEST['expiry_dateMonth']) . '-' . intval($_REQUEST['expiry_dateDay']);
	$data['expiry_date'] = parseMySQLDate($data['expiry_date'], '1');
	if($data['balance'] == '') $data['balance'] = "0.00";

	// hook: batches_before_insert
	if(function_exists('batches_before_insert')){
		$args=array();
		if(!batches_before_insert($data, getMemberInfo(), $args)){ return false; }
	}

	$o = array('silentErrors' => true);
	sql('insert into `batches` set       `item`=' . (($data['item'] !== '' && $data['item'] !== NULL) ? "'{$data['item']}'" : 'NULL') . ', `supplier`=' . (($data['supplier'] !== '' && $data['supplier'] !== NULL) ? "'{$data['supplier']}'" : 'NULL') . ', `batch_no`=' . (($data['batch_no'] !== '' && $data['batch_no'] !== NULL) ? "'{$data['batch_no']}'" : 'NULL') . ', `manufacturing_date`=' . (($data['manufacturing_date'] !== '' && $data['manufacturing_date'] !== NULL) ? "'{$data['manufacturing_date']}'" : 'NULL') . ', `expiry_date`=' . (($data['expiry_date'] !== '' && $data['expiry_date'] !== NULL) ? "'{$data['expiry_date']}'" : 'NULL'), $o);
	if($o['error']!=''){
		echo $o['error'];
		echo "<a href=\"batches_view.php?addNew_x=1\">{$Translation['< back']}</a>";
		exit;
	}

	$recID = db_insert_id(db_link());

	// hook: batches_after_insert
	if(function_exists('batches_after_insert')){
		$res = sql("select * from `batches` where `id`='" . makeSafe($recID, false) . "' limit 1", $eo);
		if($row = db_fetch_assoc($res)){
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args=array();
		if(!batches_after_insert($data, getMemberInfo(), $args)){ return $recID; }
	}

	// mm: save ownership data
	sql("insert ignore into membership_userrecords set tableName='batches', pkValue='" . makeSafe($recID, false) . "', memberID='" . makeSafe(getLoggedMemberID(), false) . "', dateAdded='" . time() . "', dateUpdated='" . time() . "', groupID='" . getLoggedGroupID() . "'", $eo);

	return $recID;
}

function batches_delete($selected_id, $AllowDeleteOfParents=false, $skipChecks=false){
	// insure referential integrity ...
	global $Translation;
	$selected_id=makeSafe($selected_id);

	// mm: can member delete record?
	$arrPerm=getTablePermissions('batches');
	$ownerGroupID=sqlValue("select groupID from membership_userrecords where tableName='batches' and pkValue='$selected_id'");
	$ownerMemberID=sqlValue("select lcase(memberID) from membership_userrecords where tableName='batches' and pkValue='$selected_id'");
	if(($arrPerm[4]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[4]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[4]==3){ // allow delete?
		// delete allowed, so continue ...
	}else{
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: batches_before_delete
	if(function_exists('batches_before_delete')){
		$args=array();
		if(!batches_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'];
	}

	// child table: transactions
	$res = sql("select `id` from `batches` where `id`='$selected_id'", $eo);
	$id = db_fetch_row($res);
	$rires = sql("select count(1) from `transactions` where `batch`='".addslashes($id[0])."'", $eo);
	$rirow = db_fetch_row($rires);
	if($rirow[0] && !$AllowDeleteOfParents && !$skipChecks){
		$RetMsg = $Translation["couldn't delete"];
		$RetMsg = str_replace("<RelatedRecords>", $rirow[0], $RetMsg);
		$RetMsg = str_replace("<TableName>", "transactions", $RetMsg);
		return $RetMsg;
	}elseif($rirow[0] && $AllowDeleteOfParents && !$skipChecks){
		$RetMsg = $Translation["confirm delete"];
		$RetMsg = str_replace("<RelatedRecords>", $rirow[0], $RetMsg);
		$RetMsg = str_replace("<TableName>", "transactions", $RetMsg);
		$RetMsg = str_replace("<Delete>", "<input type=\"button\" class=\"button\" value=\"".$Translation['yes']."\" onClick=\"window.location='batches_view.php?SelectedID=".urlencode($selected_id)."&delete_x=1&confirmed=1';\">", $RetMsg);
		$RetMsg = str_replace("<Cancel>", "<input type=\"button\" class=\"button\" value=\"".$Translation['no']."\" onClick=\"window.location='batches_view.php?SelectedID=".urlencode($selected_id)."';\">", $RetMsg);
		return $RetMsg;
	}

	sql("delete from `batches` where `id`='$selected_id'", $eo);

	// hook: batches_after_delete
	if(function_exists('batches_after_delete')){
		$args=array();
		batches_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("delete from membership_userrecords where tableName='batches' and pkValue='$selected_id'", $eo);
}

function batches_update($selected_id){
	global $Translation;

	// mm: can member edit record?
	$arrPerm=getTablePermissions('batches');
	$ownerGroupID=sqlValue("select groupID from membership_userrecords where tableName='batches' and pkValue='".makeSafe($selected_id)."'");
	$ownerMemberID=sqlValue("select lcase(memberID) from membership_userrecords where tableName='batches' and pkValue='".makeSafe($selected_id)."'");
	if(($arrPerm[3]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[3]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[3]==3){ // allow update?
		// update allowed, so continue ...
	}else{
		return false;
	}

	$data['item'] = makeSafe($_REQUEST['item']);
		if($data['item'] == empty_lookup_value){ $data['item'] = ''; }
	$data['supplier'] = makeSafe($_REQUEST['supplier']);
		if($data['supplier'] == empty_lookup_value){ $data['supplier'] = ''; }
	$data['batch_no'] = makeSafe($_REQUEST['batch_no']);
		if($data['batch_no'] == empty_lookup_value){ $data['batch_no'] = ''; }
	$data['manufacturing_date'] = intval($_REQUEST['manufacturing_dateYear']) . '-' . intval($_REQUEST['manufacturing_dateMonth']) . '-' . intval($_REQUEST['manufacturing_dateDay']);
	$data['manufacturing_date'] = parseMySQLDate($data['manufacturing_date'], '1');
	$data['expiry_date'] = intval($_REQUEST['expiry_dateYear']) . '-' . intval($_REQUEST['expiry_dateMonth']) . '-' . intval($_REQUEST['expiry_dateDay']);
	$data['expiry_date'] = parseMySQLDate($data['expiry_date'], '1');
	$data['selectedID']=makeSafe($selected_id);

	// hook: batches_before_update
	if(function_exists('batches_before_update')){
		$args=array();
		if(!batches_before_update($data, getMemberInfo(), $args)){ return false; }
	}

	$o=array('silentErrors' => true);
	sql('update `batches` set       `item`=' . (($data['item'] !== '' && $data['item'] !== NULL) ? "'{$data['item']}'" : 'NULL') . ', `supplier`=' . (($data['supplier'] !== '' && $data['supplier'] !== NULL) ? "'{$data['supplier']}'" : 'NULL') . ', `batch_no`=' . (($data['batch_no'] !== '' && $data['batch_no'] !== NULL) ? "'{$data['batch_no']}'" : 'NULL') . ', `manufacturing_date`=' . (($data['manufacturing_date'] !== '' && $data['manufacturing_date'] !== NULL) ? "'{$data['manufacturing_date']}'" : 'NULL') . ', `expiry_date`=' . (($data['expiry_date'] !== '' && $data['expiry_date'] !== NULL) ? "'{$data['expiry_date']}'" : 'NULL') . " where `id`='".makeSafe($selected_id)."'", $o);
	if($o['error']!=''){
		echo $o['error'];
		echo '<a href="batches_view.php?SelectedID='.urlencode($selected_id)."\">{$Translation['< back']}</a>";
		exit;
	}


	// hook: batches_after_update
	if(function_exists('batches_after_update')){
		$res = sql("SELECT * FROM `batches` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)){
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = $data['id'];
		$args = array();
		if(!batches_after_update($data, getMemberInfo(), $args)){ return; }
	}

	// mm: update ownership data
	sql("update membership_userrecords set dateUpdated='".time()."' where tableName='batches' and pkValue='".makeSafe($selected_id)."'", $eo);

}

function batches_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $ShowCancel = 0, $TemplateDV = '', $TemplateDVP = ''){
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;

	// mm: get table permissions
	$arrPerm=getTablePermissions('batches');
	if(!$arrPerm[1] && $selected_id==''){ return ''; }
	$AllowInsert = ($arrPerm[1] ? true : false);
	// print preview?
	$dvprint = false;
	if($selected_id && $_REQUEST['dvprint_x'] != ''){
		$dvprint = true;
	}

	$filterer_item = thisOr(undo_magic_quotes($_REQUEST['filterer_item']), '');
	$filterer_supplier = thisOr(undo_magic_quotes($_REQUEST['filterer_supplier']), '');

	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');
	// combobox: item
	$combo_item = new DataCombo;
	// combobox: supplier
	$combo_supplier = new DataCombo;
	// combobox: manufacturing_date
	$combo_manufacturing_date = new DateCombo;
	$combo_manufacturing_date->DateFormat = "dmy";
	$combo_manufacturing_date->MinYear = 1900;
	$combo_manufacturing_date->MaxYear = 2100;
	$combo_manufacturing_date->DefaultDate = parseMySQLDate('1', '1');
	$combo_manufacturing_date->MonthNames = $Translation['month names'];
	$combo_manufacturing_date->NamePrefix = 'manufacturing_date';
	// combobox: expiry_date
	$combo_expiry_date = new DateCombo;
	$combo_expiry_date->DateFormat = "dmy";
	$combo_expiry_date->MinYear = 1900;
	$combo_expiry_date->MaxYear = 2100;
	$combo_expiry_date->DefaultDate = parseMySQLDate('1', '1');
	$combo_expiry_date->MonthNames = $Translation['month names'];
	$combo_expiry_date->NamePrefix = 'expiry_date';

	if($selected_id){
		// mm: check member permissions
		if(!$arrPerm[2]){
			return "";
		}
		// mm: who is the owner?
		$ownerGroupID=sqlValue("select groupID from membership_userrecords where tableName='batches' and pkValue='".makeSafe($selected_id)."'");
		$ownerMemberID=sqlValue("select lcase(memberID) from membership_userrecords where tableName='batches' and pkValue='".makeSafe($selected_id)."'");
		if($arrPerm[2]==1 && getLoggedMemberID()!=$ownerMemberID){
			return "";
		}
		if($arrPerm[2]==2 && getLoggedGroupID()!=$ownerGroupID){
			return "";
		}

		// can edit?
		if(($arrPerm[3]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[3]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[3]==3){
			$AllowUpdate=1;
		}else{
			$AllowUpdate=0;
		}

		$res = sql("select * from `batches` where `id`='".makeSafe($selected_id)."'", $eo);
		if(!($row = db_fetch_array($res))){
			return error_message($Translation['No records found'], 'batches_view.php', false);
		}
		$urow = $row; /* unsanitized data */
		$hc = new CI_Input();
		$row = $hc->xss_clean($row); /* sanitize data */
		$combo_item->SelectedData = $row['item'];
		$combo_supplier->SelectedData = $row['supplier'];
		$combo_manufacturing_date->DefaultDate = $row['manufacturing_date'];
		$combo_expiry_date->DefaultDate = $row['expiry_date'];
	}else{
		$combo_item->SelectedData = $filterer_item;
		$combo_supplier->SelectedData = $filterer_supplier;
	}
	$combo_item->HTML = '<span id="item-container' . $rnd1 . '"></span><input type="hidden" name="item" id="item' . $rnd1 . '" value="' . html_attr($combo_item->SelectedData) . '">';
	$combo_item->MatchText = '<span id="item-container-readonly' . $rnd1 . '"></span><input type="hidden" name="item" id="item' . $rnd1 . '" value="' . html_attr($combo_item->SelectedData) . '">';
	$combo_supplier->HTML = '<span id="supplier-container' . $rnd1 . '"></span><input type="hidden" name="supplier" id="supplier' . $rnd1 . '" value="' . html_attr($combo_supplier->SelectedData) . '">';
	$combo_supplier->MatchText = '<span id="supplier-container-readonly' . $rnd1 . '"></span><input type="hidden" name="supplier" id="supplier' . $rnd1 . '" value="' . html_attr($combo_supplier->SelectedData) . '">';

	ob_start();
	?>

	<script>
		// initial lookup values
		AppGini.current_item__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['item'] : $filterer_item); ?>"};
		AppGini.current_supplier__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['supplier'] : $filterer_supplier); ?>"};

		jQuery(function() {
			setTimeout(function(){
				if(typeof(item_reload__RAND__) == 'function') item_reload__RAND__();
				if(typeof(supplier_reload__RAND__) == 'function') supplier_reload__RAND__();
			}, 10); /* we need to slightly delay client-side execution of the above code to allow AppGini.ajaxCache to work */
		});
		function item_reload__RAND__(){
		<?php if(($AllowUpdate || $AllowInsert) && !$dvprint){ ?>

			$j("#item-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c){
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { id: AppGini.current_item__RAND__.value, t: 'batches', f: 'item' },
						success: function(resp){
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="item"]').val(resp.results[0].id);
							$j('[id=item-container-readonly__RAND__]').html('<span id="item-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=items_view_parent]').hide(); }else{ $j('.btn[id=items_view_parent]').show(); }


							if(typeof(item_update_autofills__RAND__) == 'function') item_update_autofills__RAND__();
						}
					});
				},
				width: ($j('fieldset .col-xs-11').width() - select2_max_width_decrement()) + 'px',
				formatNoMatches: function(term){ return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 10,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page){ return { s: term, p: page, t: 'batches', f: 'item' }; },
					results: function(resp, page){ return resp; }
				},
				escapeMarkup: function(str){ return str; }
			}).on('change', function(e){
				AppGini.current_item__RAND__.value = e.added.id;
				AppGini.current_item__RAND__.text = e.added.text;
				$j('[name="item"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=items_view_parent]').hide(); }else{ $j('.btn[id=items_view_parent]').show(); }


				if(typeof(item_update_autofills__RAND__) == 'function') item_update_autofills__RAND__();
			});

			if(!$j("#item-container__RAND__").length){
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_item__RAND__.value, t: 'batches', f: 'item' },
					success: function(resp){
						$j('[name="item"]').val(resp.results[0].id);
						$j('[id=item-container-readonly__RAND__]').html('<span id="item-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=items_view_parent]').hide(); }else{ $j('.btn[id=items_view_parent]').show(); }

						if(typeof(item_update_autofills__RAND__) == 'function') item_update_autofills__RAND__();
					}
				});
			}

		<?php }else{ ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_item__RAND__.value, t: 'batches', f: 'item' },
				success: function(resp){
					$j('[id=item-container__RAND__], [id=item-container-readonly__RAND__]').html('<span id="item-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=items_view_parent]').hide(); }else{ $j('.btn[id=items_view_parent]').show(); }

					if(typeof(item_update_autofills__RAND__) == 'function') item_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
		function supplier_reload__RAND__(){
		<?php if(($AllowUpdate || $AllowInsert) && !$dvprint){ ?>

			$j("#supplier-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c){
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { id: AppGini.current_supplier__RAND__.value, t: 'batches', f: 'supplier' },
						success: function(resp){
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="supplier"]').val(resp.results[0].id);
							$j('[id=supplier-container-readonly__RAND__]').html('<span id="supplier-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=suppliers_view_parent]').hide(); }else{ $j('.btn[id=suppliers_view_parent]').show(); }


							if(typeof(supplier_update_autofills__RAND__) == 'function') supplier_update_autofills__RAND__();
						}
					});
				},
				width: ($j('fieldset .col-xs-11').width() - select2_max_width_decrement()) + 'px',
				formatNoMatches: function(term){ return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 10,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page){ return { s: term, p: page, t: 'batches', f: 'supplier' }; },
					results: function(resp, page){ return resp; }
				},
				escapeMarkup: function(str){ return str; }
			}).on('change', function(e){
				AppGini.current_supplier__RAND__.value = e.added.id;
				AppGini.current_supplier__RAND__.text = e.added.text;
				$j('[name="supplier"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=suppliers_view_parent]').hide(); }else{ $j('.btn[id=suppliers_view_parent]').show(); }


				if(typeof(supplier_update_autofills__RAND__) == 'function') supplier_update_autofills__RAND__();
			});

			if(!$j("#supplier-container__RAND__").length){
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_supplier__RAND__.value, t: 'batches', f: 'supplier' },
					success: function(resp){
						$j('[name="supplier"]').val(resp.results[0].id);
						$j('[id=supplier-container-readonly__RAND__]').html('<span id="supplier-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=suppliers_view_parent]').hide(); }else{ $j('.btn[id=suppliers_view_parent]').show(); }

						if(typeof(supplier_update_autofills__RAND__) == 'function') supplier_update_autofills__RAND__();
					}
				});
			}

		<?php }else{ ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_supplier__RAND__.value, t: 'batches', f: 'supplier' },
				success: function(resp){
					$j('[id=supplier-container__RAND__], [id=supplier-container-readonly__RAND__]').html('<span id="supplier-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=suppliers_view_parent]').hide(); }else{ $j('.btn[id=suppliers_view_parent]').show(); }

					if(typeof(supplier_update_autofills__RAND__) == 'function') supplier_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
	</script>
	<?php

	$lookups = str_replace('__RAND__', $rnd1, ob_get_contents());
	ob_end_clean();


	// code for template based detail view forms

	// open the detail view template
	if($dvprint){
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/batches_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	}else{
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/batches_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Batch details', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', ($_REQUEST['Embedded'] ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($AllowInsert){
		if(!$selected_id) $templateCode=str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return batches_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode=str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return batches_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	}else{
		$templateCode=str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if($_REQUEST['Embedded']){
		$backAction = 'window.parent.jQuery(\'.modal\').modal(\'hide\'); return false;';
	}else{
		$backAction = '$$(\'form\')[0].writeAttribute(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id){
		if(!$_REQUEST['Embedded']) $templateCode=str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$$(\'form\')[0].writeAttribute(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate){
			$templateCode=str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return batches_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		}else{
			$templateCode=str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm[4]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[4]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[4]==3){ // allow delete?
			$templateCode=str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" onclick="return confirm(\'' . $Translation['are you sure?'] . '\');" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		}else{
			$templateCode=str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode=str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	}else{
		$templateCode=str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode=str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		$templateCode=str_replace('<%%DESELECT_BUTTON%%>', ($ShowCancel ? '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>' : ''), $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate && !$AllowInsert) || (!$selected_id && !$AllowInsert)){
		$jsReadOnly .= "\tjQuery('#item').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#item_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('#supplier').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#supplier_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('#batch_no').replaceWith('<div class=\"form-control-static\" id=\"batch_no\">' + (jQuery('#batch_no').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#manufacturing_date').prop('readonly', true);\n";
		$jsReadOnly .= "\tjQuery('#manufacturing_dateDay, #manufacturing_dateMonth, #manufacturing_dateYear').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#expiry_date').prop('readonly', true);\n";
		$jsReadOnly .= "\tjQuery('#expiry_dateDay, #expiry_dateMonth, #expiry_dateYear').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	}elseif($AllowInsert){
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
			$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos
	$templateCode=str_replace('<%%COMBO(item)%%>', $combo_item->HTML, $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(item)%%>', $combo_item->MatchText, $templateCode);
	$templateCode=str_replace('<%%URLCOMBOTEXT(item)%%>', urlencode($combo_item->MatchText), $templateCode);
	$templateCode=str_replace('<%%COMBO(supplier)%%>', $combo_supplier->HTML, $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(supplier)%%>', $combo_supplier->MatchText, $templateCode);
	$templateCode=str_replace('<%%URLCOMBOTEXT(supplier)%%>', urlencode($combo_supplier->MatchText), $templateCode);
	$templateCode=str_replace('<%%COMBO(manufacturing_date)%%>', ($selected_id && !$arrPerm[3] ? '<div class="form-control-static">' . $combo_manufacturing_date->GetHTML(true) . '</div>' : $combo_manufacturing_date->GetHTML()), $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(manufacturing_date)%%>', $combo_manufacturing_date->GetHTML(true), $templateCode);
	$templateCode=str_replace('<%%COMBO(expiry_date)%%>', ($selected_id && !$arrPerm[3] ? '<div class="form-control-static">' . $combo_expiry_date->GetHTML(true) . '</div>' : $combo_expiry_date->GetHTML()), $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(expiry_date)%%>', $combo_expiry_date->GetHTML(true), $templateCode);

	/* lookup fields array: 'lookup field name' => array('parent table name', 'lookup field caption') */
	$lookup_fields = array(  'item' => array('items', 'Item'), 'supplier' => array('suppliers', 'Supplier'));
	foreach($lookup_fields as $luf => $ptfc){
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']){
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent hspacer-md" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] && !$_REQUEST['Embedded']){
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-success add_new_parent hspacer-md" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus-sign"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode=str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(item)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(supplier)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(batch_no)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(manufacturing_date)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(expiry_date)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(balance)%%>', '', $templateCode);

	// process values
	if($selected_id){
		$templateCode=str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		$templateCode=str_replace('<%%VALUE(item)%%>', html_attr($row['item']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(item)%%>', urlencode($urow['item']), $templateCode);
		$templateCode=str_replace('<%%VALUE(supplier)%%>', html_attr($row['supplier']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(supplier)%%>', urlencode($urow['supplier']), $templateCode);
		$templateCode=str_replace('<%%VALUE(batch_no)%%>', html_attr($row['batch_no']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(batch_no)%%>', urlencode($urow['batch_no']), $templateCode);
		$templateCode=str_replace('<%%VALUE(manufacturing_date)%%>', @date('d/m/Y', @strtotime(html_attr($row['manufacturing_date']))), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(manufacturing_date)%%>', urlencode(@date('d/m/Y', @strtotime(html_attr($urow['manufacturing_date'])))), $templateCode);
		$templateCode=str_replace('<%%VALUE(expiry_date)%%>', @date('d/m/Y', @strtotime(html_attr($row['expiry_date']))), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(expiry_date)%%>', urlencode(@date('d/m/Y', @strtotime(html_attr($urow['expiry_date'])))), $templateCode);
		$templateCode=str_replace('<%%VALUE(balance)%%>', html_attr($row['balance']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(balance)%%>', urlencode($urow['balance']), $templateCode);
	}else{
		$templateCode=str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(item)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(item)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(supplier)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(supplier)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(batch_no)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(batch_no)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(manufacturing_date)%%>', '1', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(manufacturing_date)%%>', urlencode('1'), $templateCode);
		$templateCode=str_replace('<%%VALUE(expiry_date)%%>', '1', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(expiry_date)%%>', urlencode('1'), $templateCode);
		$templateCode=str_replace('<%%VALUE(balance)%%>', '0.00', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(balance)%%>', urlencode('0.00'), $templateCode);
	}

	// process translations
	foreach($Translation as $symbol=>$trans){
		$templateCode=str_replace("<%%TRANSLATION($symbol)%%>", $trans, $templateCode);
	}

	// clear scrap
	$templateCode=str_replace('<%%', '<!-- ', $templateCode);
	$templateCode=str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if($_REQUEST['dvprint_x'] == ''){
		$templateCode .= "\n\n<script>\$j(function(){\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption){
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id){
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('batches');
	if($selected_id){
		$jdata = get_joined_record('batches', $selected_id);
		$rdata = $row;
	}
	$cache_data = array(
		'rdata' => array_map('nl2br', array_map('addslashes', $rdata)),
		'jdata' => array_map('nl2br', array_map('addslashes', $jdata)),
	);
	$templateCode .= loadView('batches-ajax-cache', $cache_data);

	// hook: batches_dv
	if(function_exists('batches_dv')){
		$args=array();
		batches_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}
?>